"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.addReactRouterDomSpecifier = void 0;

var _core = require("@babel/core");

var addReactRouterDomSpecifier = function addReactRouterDomSpecifier(path) {
  var addedSpecifier = false;
  var hasReactRouterDomImport = false;
  path.traverse({
    ImportDeclaration: function ImportDeclaration(path) {
      if (path.node.source.value !== 'react-router-dom' || addedSpecifier) return;
      hasReactRouterDomImport = true;
      var hasRouteImport = Object.values(path.node.specifiers).some(function (specifier) {
        return _core.types.isImportSpecifier(specifier) && _core.types.isIdentifier(specifier.imported) && specifier.imported.name === 'Route';
      });
      if (hasRouteImport) return;
      path.node.specifiers.push(_core.types.importSpecifier(_core.types.identifier('Route'), _core.types.identifier('Route')));
      addedSpecifier = true;
    }
  });
  if (hasReactRouterDomImport) return;
  path.unshiftContainer('body', _core.types.importDeclaration([_core.types.importSpecifier(_core.types.identifier('Route'), _core.types.identifier('Route'))], _core.types.stringLiteral('react-router-dom')));
};

exports.addReactRouterDomSpecifier = addReactRouterDomSpecifier;