"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.getReferenceProps = void 0;

var _core = require("@babel/core");

var _babelPluginMacros = require("babel-plugin-macros");

function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); enumerableOnly && (symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; })), keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = null != arguments[i] ? arguments[i] : {}; i % 2 ? ownKeys(Object(source), !0).forEach(function (key) { _defineProperty(target, key, source[key]); }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)) : ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } return target; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

// eslint-disable-next-line @typescript-eslint/no-explicit-any
var validateProps = function validateProps(props) {
  if (!('path' in props)) throw new _babelPluginMacros.MacroError('Path prop is missing');
  return true;
};

var getPropsIfCallExpression = function getPropsIfCallExpression(reference) {
  var propsExpression = reference.arguments[1];
  if (!_core.types.isObjectExpression(propsExpression)) throw new _babelPluginMacros.MacroError('');
  var props = propsExpression.properties.reduce(function (acc, prop) {
    if (!_core.types.isObjectProperty(prop) || !_core.types.isIdentifier(prop.key)) throw new _babelPluginMacros.MacroError('Invalid prop passed');
    if (!_core.types.isStringLiteral(prop.value) && !_core.types.isBooleanLiteral(prop.value)) throw new Error('Invalid prop passed');
    return _objectSpread(_objectSpread({}, acc), {}, _defineProperty({}, prop.key.name, prop.value.value));
  }, {});
  if (!validateProps(props)) throw new _babelPluginMacros.MacroError('Invalid props passed');
  return props;
};

var getPropsIfJSXOpeningElement = function getPropsIfJSXOpeningElement(reference) {
  var props = reference.attributes.reduce(function (acc, attribute) {
    if (!_core.types.isJSXAttribute(attribute) || !_core.types.isJSXIdentifier(attribute.name) || !_core.types.isLiteral(attribute.value)) return acc;
    return _objectSpread(_objectSpread({}, acc), {}, _defineProperty({}, attribute.name.name, attribute.value.value));
  }, {});
  if (!validateProps(props)) throw new _babelPluginMacros.MacroError('Props are incomplete or invalid');
  return props;
};

var getReferenceProps = function getReferenceProps(reference) {
  var parent = reference.parent;
  if (_core.types.isCallExpression(parent)) return getPropsIfCallExpression(parent);
  if (_core.types.isJSXOpeningElement(parent)) return getPropsIfJSXOpeningElement(parent);
  throw new _babelPluginMacros.MacroError('Invalid reference');
};

exports.getReferenceProps = getReferenceProps;