"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.getRoutesAndSources = void 0;

var _path = _interopRequireDefault(require("path"));

var _fastGlob = require("fast-glob");

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

var getRoutesAndSources = function getRoutesAndSources(_ref) {
  var originFile = _ref.originFile,
      relativeTargetLocation = _ref.relativeTargetLocation;

  var originDir = _path["default"].dirname(originFile);

  var targetDir = _path["default"].resolve(originDir, relativeTargetLocation);

  return (0, _fastGlob.sync)("".concat(targetDir, "/**/*")).map(function (file) {
    var targetRelativeToSource = "./".concat(_path["default"].relative(originDir, file));
    var fileNameIsIndex = Boolean(file.match(/\/index\.([tj]s[x]?)?$/));
    var routerPath = targetRelativeToSource.replace(/(?:^.*?\/)(?:.*?\/)(.*)(?:\..*$)/, '$1').replace(/\[(.*?)\]/g, function (match) {
      return ":".concat(match.slice(1, -1));
    }).replace(/(:\.\.\..*?)(?=\/|$)/g, '*');
    if (fileNameIsIndex) routerPath = routerPath.replace(/(\/index|^index)$/, '');
    var importSpecifierName = "RFBR_".concat(targetRelativeToSource.replace(/(?:^\.\/)(.*)(?:\.([tj]s[x]?)?$)/, '$1').replace(/[/-]/g, '_').replace(/[[\].]/g, ''));
    return {
      routerPath: routerPath,
      importSpecifierName: importSpecifierName,
      targetRelativeToSource: targetRelativeToSource
    };
  });
};

exports.getRoutesAndSources = getRoutesAndSources;