"use strict";

var _babelPluginMacros = require("babel-plugin-macros");

var _addReactRouterDomSpecifier = require("./add-react-router-dom-specifier");

var _addRouteImportsToFile = require("./add-route-imports-to-file");

var _getReferenceProps = require("./get-reference-props");

var _getRoutesAndSources = require("./get-routes-and-sources");

module.exports = (0, _babelPluginMacros.createMacro)(function (_ref) {
  var babel = _ref.babel,
      references = _ref.references,
      state = _ref.state;
  var types = babel.types;
  references["default"].forEach(function (reference) {
    var _reference$parentPath, _reference$parentPath2, _reference$parentPath3;

    var props = (0, _getReferenceProps.getReferenceProps)(reference);
    var filename = state.file.opts.filename;
    if (filename == null) throw new _babelPluginMacros.MacroError('');
    var routesAndSource = (0, _getRoutesAndSources.getRoutesAndSources)({
      originFile: filename,
      relativeTargetLocation: props.path
    });
    babel.traverse(state.file.path.parent, {
      Program: function Program(path) {
        (0, _addRouteImportsToFile.addRouteImportsToFile)(path, routesAndSource);
        (0, _addReactRouterDomSpecifier.addReactRouterDomSpecifier)(path);
      }
    });
    var routes = routesAndSource.map(function (_ref2, i) {
      var routerPath = _ref2.routerPath,
          importSpecifierName = _ref2.importSpecifierName,
          targetRelativeToSource = _ref2.targetRelativeToSource;
      var routeComponentIdentifier = types.jsxIdentifier(importSpecifierName);
      var routeComponentOpeningElement = types.jsxOpeningElement(routeComponentIdentifier, [], true);
      var routeComponentElement = types.jsxElement(routeComponentOpeningElement, null, []);
      var routeIdentifier = types.jsxIdentifier('Route');
      var routeOpeningElement = types.jsxOpeningElement(routeIdentifier, [types.jsxAttribute(types.jsxIdentifier('key'), types.stringLiteral(String(i))), types.jsxAttribute(types.jsxIdentifier('path'), types.stringLiteral(routerPath)), types.jsxAttribute(types.jsxIdentifier('element'), types.jSXExpressionContainer(routeComponentElement))], true);
      if (props.logRoutes) console.log("\u2139\uFE0F  Added route: /".concat(routerPath, " with component: ").concat(targetRelativeToSource));
      return types.jsxElement(routeOpeningElement, null, []);
    });
    if (types.isCallExpression(reference.parent)) return (_reference$parentPath = reference.parentPath) === null || _reference$parentPath === void 0 ? void 0 : _reference$parentPath.replaceWith(types.arrayExpression(routes));
    if (types.isJSXOpeningElement(reference.parent)) return (_reference$parentPath2 = reference.parentPath) === null || _reference$parentPath2 === void 0 ? void 0 : (_reference$parentPath3 = _reference$parentPath2.parentPath) === null || _reference$parentPath3 === void 0 ? void 0 : _reference$parentPath3.replaceWith(types.arrayExpression(routes));
    throw new _babelPluginMacros.MacroError('Invalid reference');
  });
});